//***********************************************
//*                 Main.C                      *
//***********************************************
//* W402 MPLAB C18 Advance Workshop          *
//* Written by: Richard Yang                    *
//*             Microchip Technology Inc.       *
//* Date:       12/26 2012                 *
//* Revision:	2                               *
//***********************************************
//*
//*  		        mߤG
//* ŪTC74-A7PTC1047AӤPAū׷P
//* ñNഫ10iASCII,ܦbLCDܹ
//*
//*  1. T1 Ʀ즡ūסAd򬰨
//*  2. T2 񦡷ūסAd xx.x
//*  3. QTimer1pɡACj 500mS sܪū
//*  4. ק Rec_Tmp.C ŪTū׭
//*  5. ק Timer1 _{AͥT500mSp
          	   
#include "main.h"

//********** Set the Basic Configuration Bits   *********
// OSC used the Internal RC 8MHz, Disable Watch-Dog Timer, Enable Brown-out Reset, Brown-out level = 4.3V,
// Disable Low-voltage Programming, Disable AD input on PORTB, Disable Extented Instruction Set, Enable MCLR Reset
#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

//*           wqܼƨéb Access Bank          
//*********************************************************** 

#pragma udata access My_RAM_1

near unsigned char Str_Len;
near unsigned char i;
near unsigned int T2_Buffer ;

near union
{
	int	Word ;
	unsigned char Byte[2] ;
}Byte2Word ;

near struct
{
	unsigned Timer1_Flag:1;
}Flagbits;

#pragma udata

char ASCII_String[10];

//*           wqLCDܪdréb ROM      
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG1[ ] ="  W402  Exer 2 ";
const rom char LCD_ROM_MSG2[ ] ="T1=    ";
const rom char LCD_ROM_MSG3[ ] ="T2=      ";
#pragma code

//*           wq`Ƹ    
//*********************************************************** 
// (1/32768Hz) * 16384 = 0.5 Sec
#define		Timer_Count		16384				// Set for 500mS @32.768KHz 

//***********************************************************
/*														   											*/
/* 						Main 	Program					   								*/
/*														   											*/
//***********************************************************
void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source

	InitializePORT( );
	InitializeINTs( );
	InitializeAD( );
 	InitializeTMR1( );
    Initialize_I2C_Master( );

	OpenLCD( );
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_ROM_MSG1);			// Display "WAP-002 Exer2 " on Line 1
 
	while(1)
	{
 
		if (Flagbits.Timer1_Flag)	// update Temperature on LCD every 0.5 Sec
		{
			Flagbits.Timer1_Flag=0;
			LCD_Temp_Update ( ) ;	// update Temperature
			LATDbits.LATD0 = !LATDbits.LATD0 ; 
		}
 	} 
}
 
//***************************************************
//*    The function will update the T1 & T2 on LCD 	*
//***************************************************
//*          Display LCD format on Line 1  			*
//* " T1=20* T2=101.8* " with auto position scaling *
//***************************************************
void LCD_Temp_Update (void)
{
	//*** Display TC74-A7 Temperature on LCD  ***
	LCD_Set_Cursor(1,0);
	putrsLCD(LCD_ROM_MSG2);							// DIsplay "T1=   "

	LCD_Set_Cursor(1,3);					
	Byte2Word.Word = Read_TC74_Temperature( );  	// Get Current Temperature form TC74-A7

	if ( Byte2Word.Byte[1] == 0 )
	{
		btoa(Byte2Word.Byte[0],ASCII_String);		// Convert Temp. Hax to ASCII string
  		putsLCD(ASCII_String);						// Print to LCD
		putcLCD(0xDF);							 	// Add degree symbol
	}
 	else if ( Byte2Word.Byte[1] == -1 )					// Read fail from TC74-A7, Display "--" on LCD
  	{
		putcLCD('-') ;		
		putcLCD('-') ;
	}


	//**** Display TC1047A Temperature on LCD  ***
	LCD_Set_Cursor(1,7);
	putrsLCD(LCD_ROM_MSG3);							// DIsplay "T2=   "

	LCD_Set_Cursor(1,10);					 
	T2_Buffer=Read_TC1047_Temperature( );			// Get Current Temperature from TC1047A
	if (T2_Buffer==0) putcLCD('0');
	else
	{
//*****************************************
//*     mߤG ūഫ ASCII
//* 1. Q C18 ҴѪƦ itoa( ) ഫ
//* 2. Q C18 ҴѪr׭p禡 strlen( )X ASCII_String r
//* for jppIm
//*****************************************
		itoa(T2_Buffer,ASCII_String);				// Convert to ASCII string
		Str_Len = strlen(ASCII_String);				// Get length for the ASCII-String

// ****** MrꤤpInbӦm ******		
		for (i=0;i<Str_Len;i++)						// ]wrjM 1 ~ 4 								
		{
			if (i==(Str_Len-1))						// Q(r-1)覡XpIm
			{
				if (Str_Len==1) putcLCD('0'); 		// ru@ӼƦr, bӦƤWɤ@'0'
				putcLCD('.');				 		// wƦre@ơAɤWpI
			}
			putcLCD(ASCII_String[i]);				// ܼƦrr̪U@ ASCII Code  LCD W

		}
	}		
	putcLCD(0xDF);									// Add degree symbol
}

//************************************************
//* Function: isr_low(void)                      *     
//*  - Timer 1 Interrupt for the 500mS Delay     *
//*    for update VT100 terminal				 *            
//************************************************
#pragma interruptlow isr_low 

void isr_low(void)
{
//*************************************
//*     mߤG Timer1 ]w
//* Timer1sJ500mS_pɭ
//* MTimer1_X
//*************************************

		WriteTimer1(65536-Timer_Count);				// Reload 0.5 Second value to Timer1
		PIR1bits.TMR1IF=0;							// Clear interrupt flag of Timer 1

		Flagbits.Timer1_Flag=1;						// Set for program task 
}								
#pragma code

//************************************************
//* Function: isr_low_direct                    *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.            *
//************************************************
#pragma code isrlowcode = 0x0018

void isr_low_direct(void)	
{  								
     _asm 				//begin in-line assembly
     goto isr_low		//go to isr_high function
     _endasm 			//end in-line assembly
}
#pragma code

