//***********************************************
//*                 Main.C                      *
//***********************************************
//* W-AP002 MPLAB C18 Advance Workshop          *
//* Written by: Richard Yang                    *
//*             Pr. Corporate Applications Engr.*
//*             Microchip Technology Inc.       *
//* Date:       14 January 2013                 *
//* Revision:	1                               *
//***********************************************			
//*           	   
//*********************************************************
//*         mߤ@zūױt
//*
//*@[JUطūײ`ĵAܥثeu@A
//*@Buzzerʤ覡OHPWM1X
//*  ק{ Main.c
//*********************************************************
//*
/* Include Header files  */

#include "main.h"

//********** Set the Basic Configuration Bits   *********
// OSC used the Internal RC 8MHz, Disable Watch-Dog Timer, Enable Brown-out Reset, Brown-out level = 4.3V,
// Disable Low-voltage Programming, Disable AD input on PORTB, Disable Extented Instruction Set, Enable MCLR Reset, PWM2 on RB3 Pin
#pragma config OSC=HS, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON, CCP2MX = PORTBE


#pragma romdata EEDATA=0xF00000
rom unsigned char Temp_Setting[ ] = {0xE7,0x03,0x00,0x00} ;
// ]w EEPROM ū׽dl]w (0.0OC ~ 99.9OC)
#pragma romdata

//*           wqLCDܪdréb ROM      
//*********************************************************** 

#pragma romdata RomData

const rom char *LCD_MSG[8]= {"  Microchip W402",	//0   LCD display Table
							 " Cooling System ",	//1
							 "T1=     T2=     ", 	//2
							 "PWM Duty =      ",	//3
							 "Over Temperature",	//4
							 "Lose Temperature",	//5
							 " Cooling Normal ",    //6
							 "System  Shutdown",	//7
							};

const rom char *Disp_Status[6]={"Over Temperature  ",  	//0   VT-100 Display Table
									"Higher Temperature", 	//1
									"Normal Temperature",	//2
									"Lower Temperature ",	//3
									"Lose Temperature  ", 	//4
									"System Shutdown   ",	//5
									};

const rom char Degree_C[]=" deg.C   ";					//	VT-100 display Table

//*           wq idata ܼƨéb Access Bank          
//*********************************************************** 

#pragma idata access My_RAM_1

near unsigned char Rec_Data=0;
near unsigned char Timer1_Count=0;
near int Slave_update_Count=0;
near char Str_Len=0;
near unsigned char i=0;
near unsigned char SW2_Debance=0;
near unsigned char LCD_Count=0;
near unsigned char Buzzer_Count=0;

near union
{
	unsigned char Flag;	
	struct {
			unsigned Key_Flag:1;
    		unsigned Timer1_Flag:1;
    		unsigned SW2_Flag:1;
			unsigned Buzzer_On_Flag:1;
			unsigned Buzzer_Fast_Flag:1;
			unsigned Buzzer_Mid_Flag:1;
			unsigned Buzzer_Slow_Flag:1;
			unsigned Shutdown_Flag:1;
    		};		
} Flagbits=0;

near union
{
	unsigned char Count;	
	struct {
			unsigned B0:1;
    		unsigned B1:1;
    		unsigned B2:1;
    		unsigned B3:1;
    		unsigned B4:1;
    		unsigned B5:1;
    		};		
} Bz=0;

#pragma idata

//*           wq udata ܼƨéb Access Bank          
//*********************************************************** 

#pragma udata access My_RAM_2

near int EEPROM_Hi_Setting;
near int EEPROM_Low_Setting;
near long Temp_Diff;
near int Temp_Range;
near int Temp_PWM;
near long Temp_24bit;
near int T2_Buffer;
near char T1_Buffer;
near char Disp_Duty;

near union 
{
int Word;
unsigned char Byte[2];
}EEPROM;

#pragma udata


char ASCII_String[10];


//***********************************************************
/*														   */
/* 						Main 	Program					   */
/*														   */
//***********************************************************
void main(void)
{
	InitializePORT( );
 	InitializeINTs( );
 	InitializeTMR1( );	
	InitializeTMR2( );
	InitializePWM( );
	InitializeUSART( );
    Initialize_I2C_Master( );
 	InitializeAD( );

	Buzzer_Count=0x08;	    		// 2 short beep for power up
	Flagbits.Buzzer_Fast_Flag=1;

	OpenLCD( );
	LCD_Set_Cursor(0,0);
 	putrsLCD(LCD_MSG[0]);
	LCD_Set_Cursor(1,0);
 	putrsLCD(LCD_MSG[1]);
//	LCD_Count=30;

	InitializeVT100( );				// Clear Terminal screen & put cursoe on (0,0)	
	VT100_Fill_Screen(0);			// Fill the initialize charactor on VT-100
	VT100_Cursor_Position(8,51);

	TRISAbits.TRISA0 = 1 ;
	LATAbits.LATA0 = 0 ;

	while(1)
	{
		Rec_Cmd_Check( );
		Key_Press_Check( );

		if (Flagbits.Timer1_Flag)    // Timer1 C 0.1 _@
		{
			Flagbits.Timer1_Flag=0;


			switch (Timer1_Count)
			{
				case 0x00:
				if (LCD_Count==0) LCD_Temp_Update( );	
				break;

				case 0x01:
			    VT_100_Update( );
				break;

				case 0x02:
				EEPROM_Update( );
				break;

				case 0x03:
				PWM_Control( );
				break;

				case 0x04:
				Temp_Compare( );
				break;
			}
		}

 	} 
}

void Key_Press_Check(void)
{
 	if (Flagbits.Key_Flag)				// SW2 press ?
	{
		Flagbits.Key_Flag=0;			// Clear key press flag
		Flagbits.Shutdown_Flag=!Flagbits.Shutdown_Flag;	// toggle the flag
		if (Flagbits.Shutdown_Flag) Cooling_Shutdown( ); 
		else Cooling_Auto( );
	}
}

void Temp_Compare(void)
{
	if (Flagbits.Shutdown_Flag==1)		// =1, Shutdown
	{
		VT100_Cursor_Position(15,58);
		putrsUSART(Disp_Status[5]);
		LCD_Set_Cursor(1,0);
		putrsLCD(LCD_MSG[7]);
	}
	else								// =0, Normal Operation
	{
		VT100_Cursor_Position(15,58);
//*
//*********************************************************************
//*     @@ mߤ@`ūתܻPĵ
//*
//*@1. pGū׶WL99%A"Over Temeperature" bVT100(15A58C)
//*     LCDĤG
//*  2. pGū׶WL99%APĵT20
//*********************************************************************
//*
		if (Disp_Duty >= 99)
		{
???					// Display "Over Temeperature" on VT100
					// Set Line 2 for LCD
					// Display "Over Temeperature" on LCD

			   		// Buzzer On 20 Sec with Fast mode
			 		// Set Buzzer for Fast alarm mode
					//
					//
		}
		else if (Disp_Duty >= 75)
		{
			putrsUSART(Disp_Status[1]);		// Display "Higher Temperature"
			LCD_Set_Cursor(1,0);
			putrsLCD(LCD_MSG[3]);
			LCD_Set_Cursor(1,11);
			btoa(Disp_Duty,ASCII_String);
			putsLCD(ASCII_String);
			putcLCD('%');

			Buzzer_Count=100;	    		// Buzzer On 10 Sec with Slow mode
			Flagbits.Buzzer_Fast_Flag=0;
			Flagbits.Buzzer_Mid_Flag=1;
			Flagbits.Buzzer_Slow_Flag==0;
		}
		else if (Disp_Duty >= 25)
		{
			putrsUSART(Disp_Status[2]);		// Display "Normal Temperature"
			LCD_Set_Cursor(1,0);
			putrsLCD(LCD_MSG[3]);
			LCD_Set_Cursor(1,11);
			btoa(Disp_Duty,ASCII_String);
			putsLCD(ASCII_String);
			putcLCD('%');

			Buzzer_Count=0;	    				// Buzzer Off
			Flagbits.Buzzer_Fast_Flag=0;
			Flagbits.Buzzer_Mid_Flag=0;
			Flagbits.Buzzer_Slow_Flag==0;
		}
		else if (Disp_Duty >= 1)
		{		
			putrsUSART(Disp_Status[3]);		// Display "Lower Temperature "
			LCD_Set_Cursor(1,0);
			putrsLCD(LCD_MSG[3]);
			LCD_Set_Cursor(1,11);
			btoa(Disp_Duty,ASCII_String);
			putsLCD(ASCII_String);
			putcLCD('%');

			Buzzer_Count=0;	    				// Buzzer Off
			Flagbits.Buzzer_Fast_Flag=0;
			Flagbits.Buzzer_Mid_Flag=0;
			Flagbits.Buzzer_Slow_Flag==0;
		}
		else
		{
			putrsUSART(Disp_Status[4]);		// Display "Lose Temperature  "
			LCD_Set_Cursor(1,0);
			putrsLCD(LCD_MSG[5]);

			Buzzer_Count=100;	    		// Buzzer On 10 Sec with Slow mode
			Flagbits.Buzzer_Fast_Flag=0;
			Flagbits.Buzzer_Mid_Flag=0;
			Flagbits.Buzzer_Slow_Flag=1;
		}
	}
}

//*******************************************************
//*            Calculate The PWM Duty Cycle    			*
//*														*
//*    PWM = 0x3FF * (T2 - T2_Min)/(T2_Max - T2_Min)	*
//*******************************************************


void PWM_Control(void)
{
	if (Flagbits.Shutdown_Flag==1)		// =1, Shutdown
	{
		VT100_Cursor_Position(13,69);	
		Print_Byte('-');
		Print_Byte('-');
		Print_Byte('-');
		Print_Byte('%');
	}
	else								// =0, Normal Operation
	{

		if (T2_Buffer>=EEPROM_Hi_Setting) Temp_PWM= 0x3FF;
		else if (T2_Buffer<=EEPROM_Low_Setting) Temp_PWM= 0x001;
		else
		{
			Temp_Diff = (long) T2_Buffer-EEPROM_Low_Setting;
			Temp_Range = EEPROM_Hi_Setting - EEPROM_Low_Setting;
			Temp_24bit= 0x3FF * Temp_Diff;
 		   	Temp_PWM = (int) (Temp_24bit / Temp_Range);
		}
		SetDCPWM2(Temp_PWM);
	
		Temp_24bit=(long) Temp_PWM;
		Temp_24bit= 100 * Temp_24bit;
		Disp_Duty= (char) (Temp_24bit / 0x3FF);

		VT100_Cursor_Position(13,69);			 
	 	btoa(Disp_Duty,ASCII_String);
		VT100_Clear_Right( );
		putsUSART(ASCII_String);
		Print_Byte('%');
	}
}

//***************************************************
//*    The function will update the T1 & T2 on LCD 	*
//***************************************************
//*          Display LCD format on Line 1  			*
//* " T1=20* T2=101.8* " with auto position scaling *
//***************************************************
void LCD_Temp_Update (void)
{
		LCD_Set_Cursor(0,0);					// Clear Line 1of LCD display
		for (i=0;i<16;i++)putcLCD(' ');

//*** put the Temperature 1  ****
	
		LCD_Set_Cursor(0,0);
		putcLCD('T');
		putcLCD('1');
		putcLCD('=');

		T1_Buffer= Read_TC74_Temperature( );  	// Put the Temperature 1 on LCD
		btoa(T1_Buffer,ASCII_String);
  	 	putsLCD(ASCII_String);
		putcLCD(0xDF);							// Add degree symbol
		putcLCD(' ');

//*** put the Temperature 2  ****
		if (Flagbits.SW2_Flag)
		{
			putcLCD('V');
			putcLCD('R');
		}
		else
		{
			putcLCD('T');
			putcLCD('2');
		}

		putcLCD('=');

		T2_Buffer=Read_TC1047_Temperature( );

		if (T2_Buffer==0) putcLCD('0');			// T2 = 0 , Display "0" on LCD
		else
		{
			itoa(T2_Buffer,ASCII_String);		// Convert to ASCII string
			Str_Len = strlen(ASCII_String);		// Get length for the ASCII-String
		
			for (i=0;i<Str_Len;i++)							
			{
				if (i==(Str_Len-1))				// Looking for the point
				{
					if (Str_Len==1)putcLCD('0'); // Just one digital, add "0"
					putcLCD('.');				 // Add the point
				}

				putcLCD(ASCII_String[i]);		// Display the ASCII_String on LCD

			}
		}	
			
		putcLCD(0xDF);							// Add degree symbol

}



void VT_100_Update(void)
{
	Slave_update_Count ++;						// Update the Slave Update counter
  	itoa(Slave_update_Count,ASCII_String);		
  	VT100_Cursor_Position(11,39);
	VT100_Clear_Right( );
	putsUSART(ASCII_String);

	VT100_Cursor_Position(13,32);				// Update Temperature 1
 	btoa(T1_Buffer,ASCII_String);
  	putsUSART(ASCII_String);
 	putrsUSART(Degree_C);							 
 	WriteUSART(' ');

	T2_Buffer=Read_TC1047_Temperature( );
	VT100_Cursor_Position(15,32);				// Update Temperature 2
	Print_Temperature(T2_Buffer);
		
}

void Print_Temperature(int Data)
{
	if (Data==0) WriteUSART('0');				// T2 = 0 , Display "0" on LCD
	else
	{
 		itoa(Data,ASCII_String);			  	// Convert to ASCII string
		Str_Len = strlen(ASCII_String);			// Get length for the ASCII-String
		
		for (i=0;i<Str_Len;i++)							
		{
			if (i==(Str_Len-1))					// Looking for the point
			{
				if (Str_Len==1) Print_Byte('0');	// Just one digital, add "0"
				Print_Byte('.');			    // Add the point
			}
		
			Print_Byte(ASCII_String[i]);		// Display the ASCII_String on LCD
		}
	}
 	putrsUSART(Degree_C);
}

void Print_Byte(unsigned char Byte)
{
	while (BusyUSART( ));
	WriteUSART(Byte);
}


void EEPROM_Update(void)
{
	EEPROM.Byte[0]=EE_Read(0x00);		// Read Maximun Temperature Setting fromEEPROM
	EEPROM.Byte[1]=EE_Read(0x01);
	EEPROM_Hi_Setting=EEPROM.Word;

	VT100_Cursor_Position(20,68);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(20,68);
	Print_Temperature(EEPROM_Hi_Setting);

	EEPROM.Byte[0]=EE_Read(0x02);		// Read Maximun Temperature Setting fromEEPROM
	EEPROM.Byte[1]=EE_Read(0x03);
	EEPROM_Low_Setting=EEPROM.Word;
	VT100_Cursor_Position(21,68);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(21,68);
	Print_Temperature(EEPROM_Low_Setting);

}
//************************************************************
//*             Internal EEPROM Access Function				 *
//************************************************************

void EE_Write (unsigned char EE_Address, unsigned char EE_Data)
{
	PIR2bits.EEIF = 0;
	EEADR = EE_Address;
	EEDATA = EE_Data;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0 ;
	EECON1bits.WREN = 1;
	INTCONbits.GIE = 0;

	_asm
		MOVLW	0X55
		MOVWF	EECON2,0
		MOVLW	0XAA
		MOVWF	EECON2,0
		BSF		EECON1,1,0
	_endasm

	INTCONbits.GIE = 1;
	while (!PIR2bits.EEIF);
	PIR2bits.EEIF = 0;
	EECON1bits.WREN = 0;
}

unsigned char EE_Read (unsigned char EE_Address)
{
	EEADR = EE_Address;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0 ;
	EECON1bits.RD = 1;
	return EEDATA;
}


//************************************************
//*       #pragma Interrupt Declarations         *
//************************************************
//************************************************
//* Function: isr_high_direct                    *
//*   - Direct execution to the actual           *
//*     high-priority interrupt code.            *
//************************************************
#pragma code isrhighcode = 0x0008

void isr_high_direct(void)	
{  								
     _asm 			//begin in-line assembly
     goto isr_high	//go to isr_high function
     _endasm 		//end in-line assembly
}
#pragma code

//************************************************
//* Function: isr_high(void)                     *     
//*   High priority interrupt:	                 *
//*   - Received a serial data from RS-232       *
//*     Save the received data to buffer Rec_Data*
//*   - Timer 2 Interrupt : 5 mS 				 *                     
//************************************************
#pragma interrupt isr_high 

void isr_high(void)
{
 	if (PIR1bits.RCIF)
	{
		 Rec_Data=ReadUSART();				// Get RS-232 data
	}

	if (PIR1bits.TMR2IF)

	{		
 		PIR1bits.TMR2IF=0;
 		
 		if (SW2_Debance!=0)
 		{	
			if (!SW2 | !SW3) SW2_Debance=10;
			else	SW2_Debance--;
		}	
		else 
		{
			if (!SW3)
			{ 
				Flagbits.Key_Flag =1 ;
		 		SW2_Debance=10;
			}
			if (!SW2)
			{ 	
				Flagbits.SW2_Flag=!Flagbits.SW2_Flag; 
				SW2_Debance=10;
			}
		}		
	}
}					
#pragma code

//************************************************
//* Function: isr_low_direct                    *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.            *
//************************************************
#pragma code isrlowcode = 0x0018

void isr_low_direct(void)	
{  								
     _asm 			//begin in-line assembly
     goto isr_low	//go to isr_high function
     _endasm 		//end in-line assembly
}
#pragma code

//************************************************
//* Function: isr_low(void)                      *     
//*  - Timer 1 Interrupt for the 0.1 Second Delay*        
//************************************************
#pragma interruptlow isr_low 

void isr_low(void)
{

		TMR1H = (0xFFFF-Timer_Count)/256;			
		TMR1L = (0xFFFF-Timer_Count)%256;		// Reload 0.1 Second value to Timer1
		PIR1bits.TMR1IF=0;						// Clear interrupt flag of Timer 1

		Flagbits.Timer1_Flag=1;					// Set for program task 
		if (Timer1_Count==5) Timer1_Count =0;
		else	Timer1_Count ++;


		if (LCD_Count!=0) LCD_Count--;			// LCD display delay count


		if (Buzzer_Count==0) TRISCbits.TRISC2=1; 	//  Buzzer control , If the count=0, Buzzer off
		else 
		{
			Buzzer_Count--;	
			Bz.Count++;

			if (Flagbits.Buzzer_Fast_Flag==1)			// Check the alarm with fast mode
			{		
				if (Bz.B1==1) TRISCbits.TRISC2=0;		// Turn On the PWM1 output (Buzzer)
				else TRISCbits.TRISC2=1;				// Turn off the PWM1 output (Buzzer)  
			}			
			else if (Flagbits.Buzzer_Mid_Flag==1)		// Check the alarm with slow mode
			{		
 				if (Bz.B2==1) TRISCbits.TRISC2=0;		// Turn On the PWM1 output (Buzzer)
				else TRISCbits.TRISC2=1;				// Turn off the PWM1 output (Buzzer)  

			}
			else if (Flagbits.Buzzer_Slow_Flag==1)		// Check the alarm with slow mode
			{		
 				if (Bz.B4==1) TRISCbits.TRISC2=0;		// Turn On the PWM1 output (Buzzer)
				else TRISCbits.TRISC2=1;				// Turn off the PWM1 output (Buzzer)  

			}
		
		}

}								
#pragma code
